          move.w      $110,a0
          lea.l       procs,a1
          jsr         (a0)
          rts
procs     dc.w        5
          dc.w        m_move-*
          dc.b        6
          dc.b        'm_move'
          dc.w        mdmove-*
          dc.b        6
          dc.b        'mdmove' 
          dc.w        mclear-*
          dc.b        6
          dc.b        'mclear'
          dc.w        transd-*
          dc.b        6
          dc.b        'transd' 
          dc.w        transu-*
          dc.b        6
          dc.b        'transu'
          dc.w        0 
          dc.w        4
          dc.w        clclok-*
          dc.b        6
          dc.b        'clclok'
          dc.w        getrid-*
          dc.b        6
          dc.b        'getrid'
          dc.w        a_filt-*
          dc.b        6
          dc.b        'a_filt'
          dc.w        b_filt-*
          dc.b        6
          dc.b        'b_filt'
          dc.w        0

m_move    move.w      $118,a0
          jsr         (a0)
          bne         mgo
          moveq       #-15,d0
          cmpi.w      #3,d3
          bne         mgo
          move.l      0(a6,a1.l),a2
          move.l      4(a6,a1.l),a4
          move.l      8(a6,a1.l),d1
          beq.s       mret
          subq.l      #1,d1
mloop     move.b      (a2)+,(a4)+
          dbf         d1,mloop
mret      clr.l       d0
mgo       rts

mdmove    move.w      $118,a0
          jsr         (a0)
          bne         dgo
          moveq       #-15,d0
          cmpi.w      #3,d3
          bne         dgo
          move.l      0(a6,a1.l),a2
          move.l      4(a6,a1.l),a4
          move.l      8(a6,a1.l),d1
          beq.s       dret
          subq.l      #1,d1
dloop     move.b      (a2),(a4)
          subq.l      #1,a2
          subq.l      #1,a4
          dbf         d1,dloop
dret      clr.l       d0
dgo       rts

mclear    move.w      $118,a0
          jsr         (a0)
          bne         cgo
          moveq       #-15,d0
          cmpi.w      #2,d3
          bne         cgo
          move.l      0(a6,a1.l),a2
          move.l      4(a6,a1.l),d1
          beq.s       cret 
          subq.l      #1,d1
cloop     move.b      #0,(a2)+
          dbf         d1,cloop
cret      clr.l       d0
cgo       rts

transd    move.w      $118,a0
          jsr         (a0)
          bne         sgo
          moveq       #-15,d0
          cmpi.w      #4,d3
          bne         sgo
          move.l      0(a6,a1.l),a2
          move.l      4(a6,a1.l),d1
          move.l      8(a6,a1.l),d3
          move.l      12(a6,a1.l),d4
sloop     cmpi.b      #16,d4
          beq.s       skip
          move.b      (a2),d2
          andi.b      #%00001111,d2
          cmp.b       d2,d4
          bne.s       n
skip      move.b      (a2),d2
          lsr.b       #4,d2
          cmpi.b      #8,d2
          beq.s       ys
          cmpi.b      #9,d2
          bne.s       n
ys        adda.l      #1,a2
          sub.b       d3,(a2)
          suba.l      #1,a2
n         adda.l      #3,a2
          subq.l      #1,d1
          bne.s       sloop
sret      clr.l       d0
sgo       rts

transu    move.w      $118,a0
          jsr         (a0)
          bne         ugo
          moveq       #-15,d0
          cmpi.w      #4,d3
          bne         ugo
          move.l      0(a6,a1.l),a2
          move.l      4(a6,a1.l),d1
          move.l      8(a6,a1.l),d3
          move.l      12(a6,a1.l),d4
uloop     cmpi.b      #16,d4
          beq.s       ukip
          move.b      (a2),d2
          andi.b      #%00001111,d2
          cmp.b       d2,d4
          bne.s       no            
ukip      move.b      (a2),d2
          lsr.b       #4,d2
          cmpi.b      #8,d2
          beq.s       yes
          cmpi.b      #9,d2
          bne.s       no
yes       adda.l      #1,a2
          add.b       d3,(a2)
          suba.l      #1,a2
no        adda.l      #3,a2
          subq.l      #1,d1
          bne.s       uloop
uret      clr.l       d0
ugo       rts

clclok    move.w      $118,a0
          jsr         (a0)
          bne         ccgo
          moveq       #-15,d0
          cmpi.w      #2,d3
          bne         ccgo
          move.l      0(a6,a1.l),a2
          move.l      4(a6,a1.l),d1
          clr.l       d4
          tst.l       d1
          beq         lintofp
          subq.w      #1,d1
ccloop    add.w       (a2)+,d4
          dbf         d1,ccloop
          bra         lintofp
ccret     clr.l       d0
ccgo      rts

getrid    move.w      $118,a0
          jsr         (a0)
          bne         vgo
          moveq       #-15,d0
          cmpi.w      #6,d3
          bne         vgo
          move.l      0(a6,a1.l),a2       ; ptr to event buff S
          move.l      4(a6,a1.l),a3       ; ptr to delay buff S
          move.l      8(a6,a1.l),a4       ; ptr to event buff D
          move.l      12(a6,a1.l),a5      ; ptr to delay buff D
          move.l      16(a6,a1.l),d1      ; channel to remove
          move.l      20(a6,a1.l),d2      ; # of events  S

          clr.l       d4
          move.w      d2,d4               ; save # events
          subq.w      #1,d2               ; dec # of events for loop

          subq.b      #1,d1               ; midi chan number one less
          andi.b      #%00001111,d1       ; only channel to remove in d1
          move.w      -2(a3),-2(a5)       ; copy init delay
;
vloop     move.b      (a2),d3             ; status byte in d3
          andi.b      #%00001111,d3       ; mask out all except channel #
          cmp.b       d1,d3               ; is it to be removed
          bne         vcopy               ; no then copy
          move.w      (a3)+,d5            ; get current delay S
          add.w       d5,-2(a5)           ; add it to previous delay D
          subq.w      #1,d4               ; dec # events
          adda.l      #3,a2               ; inc ev buff to next status S
          dbf         d2,vloop            ; loop if not done
          bra.s       vdone

vcopy     moveq       #2,d6               ; three bytes to copy
vlp       move.b      (a2)+,(a4)+
          dbf         d6,vlp

          move.w      (a3)+,(a5)+         ; two bytes to copy
          dbf         d2,vloop            ; loop if not done

vdone     bra         lintofp             ; return d4 new event #
vret      clr.l       d0
vgo       rts

a_filt    move.w      $118,a0
          jsr         (a0)
          bne         zgo
          moveq       #-15,d0
          cmpi.w      #5,d3
          bne         zgo
          move.l      0(a6,a1.l),a2       ; ptr to event buff S
          move.l      4(a6,a1.l),a3       ; ptr to delay buff S
          move.l      8(a6,a1.l),a4       ; ptr to event buff D
          move.l      12(a6,a1.l),a5      ; ptr to delay buff D
          move.l      16(a6,a1.l),d2      ; # of events  S

          clr.l       d4
          move.w      d2,d4               ; save # events
          subq.w      #1,d2               ; dec # of events for loop

zloop     move.b      (a2),d3             ; status byte in d3
          andi.b      #%11110000,d3       ; mask out all but status
          move.b      #%11010000,d1       ; get C.A.T status
          cmp.b       d1,d3               ; is it to be removed
          beq         zrem                ; yes then remove
          move.b      #%10100000,d1       ; get P.A.T. status
          cmp.b       d1,d3               ; is it to be removed
          beq         zrem                ; yes then remove
                                          ; no then copy
zcopy     moveq       #2,d6               ; three bytes to copy
zlp       move.b      (a2)+,(a4)+
          dbf         d6,zlp

          move.w      (a3)+,(a5)+         ; two bytes to copy
          dbf         d2,zloop            ; loop if not done
          bra         zdone

zrem      adda.l      #1,a2               ; inc ev buff ptr past status
zlp2      tst.b       (a2)+               ; is the next a status
          bpl         zlp2                ; no then test next
          suba.l      #1,a2               ; dec ptr to status found
          move.w      (a3)+,d5            ; get current delay A
          suba.l      #2,a5               ; get ptr to prev delay B
          add.w       d5,(a5)             ; add curr del A to prev delay B
          subq.w      #1,d4               ; dec # events
          adda.l      #2,a5               ; get ptr to current delay B
          dbf         d2,zloop            ; loop if not done

zdone     bra         lintofp             ; return d4 new event #
zret      clr.l       d0
zgo       rts

b_filt    move.w      $118,a0
          jsr         (a0)
          bne         lgo
          moveq       #-15,d0
          cmpi.w      #5,d3
          bne         lgo
          move.l      0(a6,a1.l),a2       ; ptr to event buff S
          move.l      4(a6,a1.l),a3       ; ptr to delay buff S
          move.l      8(a6,a1.l),a4       ; ptr to event buff D
          move.l      12(a6,a1.l),a5      ; ptr to delay buff D
          move.l      16(a6,a1.l),d2      ; # of events  S

          clr.l       d4
          move.w      d2,d4               ; save # events
          subq.w      #1,d2               ; dec # of events for loop

lloop     move.b      (a2),d3             ; status byte in d3
          andi.b      #%11110000,d3       ; mask out all but status
          move.b      #%11100000,d1       ; get PB status
          cmp.b       d1,d3               ; is it to be removed
          beq         lrem                ; yes then remove
                                          ; no then copy
lcopy     moveq       #2,d6               ; three bytes to copy
llp       move.b      (a2)+,(a4)+
          dbf         d6,llp

          move.w      (a3)+,(a5)+         ; two bytes to copy
          dbf         d2,lloop            ; loop if not done
          bra         ldone

lrem      adda.l      #1,a2               ; inc ev buff ptr past status
llp2      tst.b       (a2)+               ; is the next a status
          bpl         llp2                ; no then test next
          suba.l      #1,a2               ; dec ptr to status found
          move.w      (a3)+,d5            ; get current delay A
          suba.l      #2,a5               ; get ptr to prev delay B
          add.w       d5,(a5)             ; add curr del A to prev delay B
          subq.w      #1,d4               ; dec # events
          adda.l      #2,a5               ; get ptr to current delay B
          dbf         d2,lloop            ; loop if not done

ldone     bra.s       lintofp             ; return d4 new event #
lret      clr.l       d0
lgo       rts
lintofp   move.l      a1,$58(a6)
          moveq       #18,d1
          move.w      $11a,a2
          jsr         (a2)
          move.l      $58(a6),a1
          subq.l      #2,a1
          swap        d4
          move.w      d4,d5
          move.w      d4,0(a6,a1.l)
          move.w      $11c,a2
          moveq       #8,d0
          jsr         (a2)
          tst.w       d5
          bpl.s       nosign
          subq.l      #6,a1
          move.w      #$813,0(a6,a1.l)
          move.l      #$10000000,2(a6,a1.l)
          moveq       #$0a,d0
          jsr         (a2)
nosign    subq.l      #6,a1
          move.w      #$813,0(a6,a1.l)
          move.l      #$10000000,2(a6,a1.l)
          moveq       #$0e,d0
          jsr         (a2)
          swap        d4
          move.w      d4,d5
          subq.l      #2,a1

           move.w     d4,0(a6,a1.l)
           moveq      #8,d0
           jsr        (a2)
           tst.w      d5
           bpl.s      posnum
           subq.l    #6,a1
           move.w    #$813,0(a6,a1.l)
           move.l    #$10000000,2(a6,a1.l)
           moveq     #$0a,d0
           jsr       (a2)
posnum     moveq     #$0a,d0
           jsr       (a2)
           move.l    a1,$58(a6)
           moveq     #2,d4
           rts
           end
